Index: sandbox/newExpressoMail/newExpressoMail/inc/load_lang.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/inc/load_lang.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/inc/load_lang.php	(revision 7265)
@@ -0,0 +1,32 @@
+<?php
+		/*************************************************************************** 
+		* Expresso Livre                                                           * 
+		* http://www.expressolivre.org                                             * 
+		* --------------------------------------------                             * 
+		*  This program is free software; you can redistribute it and/or modify it * 
+		*  under the terms of the GNU General Public License as published by the   * 
+		*  Free Software Foundation; either version 2 of the License, or (at your  * 
+		*  option) any later version.                                              * 
+		\**************************************************************************/ 
+		
+// Load the lang of the module.
+	if(isset($offline_language)) { //Expresso offline, quando o gears sincroniza com uma nova versão, não é dado acesso as sessões do usuário, e é preciso o nome do arquivo de linguagens na session abaixo.
+		$_SESSION['phpgw_info']['expressomail']['user']['preferences']['common']['lang'] = $offline_language;
+	}
+	
+	$array_keys = array();
+	$fn = 'setup/phpgw_'.$_SESSION['phpgw_info']['expressomail']['user']['preferences']['common']['lang'].'.lang';			
+	if (file_exists($fn)){
+		$fp = fopen($fn,'r');
+		while ($data = fgets($fp,16000)){
+			list($message_id,$app_name,$null,$content) = explode("\t",substr($data,0,-1));
+			$expressomaillang[$message_id] =  $content;
+			$_SESSION['phpgw_info']['expressomail']['lang'][$message_id] = $content;
+		}
+		fclose($fp);
+	}
+	
+	foreach($expressomaillang as $key => $value)
+		$script .= "array_lang['".str_replace("'","\'",strtolower($key))."'] = '".str_replace("'","\'",$value)."';\n";
+	echo "<script type='text/javascript'>$script</script>";
+?>
Index: sandbox/newExpressoMail/newExpressoMail/inc/style.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/inc/style.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/inc/style.php	(revision 7265)
@@ -0,0 +1,53 @@
+<?php
+/**
+ * Created by JetBrains PhpStorm.
+ * User: Gustavo
+ * Date: 19/09/12
+ * Time: 11:14
+ * To change this template use File | Settings | File Templates.
+ */
+    class ClassAutoloader {
+        public function __construct() {
+            spl_autoload_register(array($this, 'loader'));
+        }
+        private function loader($className) {
+            include "../".str_replace('\\', '/', $className) . '.php';
+        }
+    }
+    define( 'PLUGINSURL' , '../../prototype/plugins' );
+    define( 'MODULESURL' , '../../prototype/modules/newMail' );
+
+    $autoloader = new ClassAutoloader();
+
+    use Assetic\Asset\AssetCollection;
+    use Assetic\Asset\FileAsset;
+    use Assetic\Asset\GlobAsset;
+
+    $css = new AssetCollection(
+        array(
+            new FileAsset(MODULESURL.'/css/reset.css'),
+            new FileAsset(PLUGINSURL.'/jquery/jquery-ui.css'),
+            new FileAsset(PLUGINSURL.'/wijmo/jquery-ui.wijmo.css'),
+            new FileAsset(PLUGINSURL.'/wijmo/jquery.wijmo-open.2.2.0.css'),
+            new FileAsset(PLUGINSURL.'/icalendar/jquery.icalendar.css'),
+            new FileAsset(PLUGINSURL.'/fgmenu/fg.menu.css'),
+            new FileAsset(PLUGINSURL.'/fileupload/jquery.fileupload-ui.css'),
+            new FileAsset(PLUGINSURL.'/jpicker/css/jPicker-1.1.6.min.css'),
+            new FileAsset(PLUGINSURL.'/jpicker/jPicker.css'),
+            new FileAsset(PLUGINSURL.'/farbtastic/farbtastic.css'),
+            new FileAsset(PLUGINSURL.'/timepicker/jquery-ui-timepicker-addon.css'),
+            new FileAsset(PLUGINSURL.'/zebradialog/css/zebra_dialog.css'),
+            new FileAsset(PLUGINSURL.'/treeview/jquery.treeview.css'),
+            new FileAsset(PLUGINSURL.'/jqgrid/css/ui.jqgrid.css'),
+
+
+            new FileAsset(MODULESURL.'/../attach_message/attach_message.css'),
+            new FileAsset(MODULESURL.'/css/layout.css'),
+            new FileAsset(MODULESURL.'/css/style.css'),
+            new FileAsset(MODULESURL.'/css/grid.css'),
+            new FileAsset(MODULESURL.'/css/main.css')
+        )
+     );
+    header('Content-Type: text/css');
+    echo $css->dump();
+?>
Index: sandbox/newExpressoMail/newExpressoMail/inc/core.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/inc/core.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/inc/core.php	(revision 7265)
@@ -0,0 +1,59 @@
+<?php
+/**
+ * Created by JetBrains PhpStorm.
+ * User: Gustavo
+ * Date: 19/09/12
+ * Time: 09:49
+ * To change this template use File | Settings | File Templates.
+ */
+    class ClassAutoloader {
+        public function __construct() {
+            spl_autoload_register(array($this, 'loader'));
+        }
+        private function loader($className) {
+            include "../".str_replace('\\', '/', $className) . '.php';
+        }
+    }
+    define( 'PLUGINSURL' , '../../prototype/plugins' );
+    define( 'MODULESURL' , '../../prototype/modules/newMail' );
+
+    $autoloader = new ClassAutoloader();
+
+    use Assetic\Asset\AssetCollection;
+    use Assetic\Asset\FileAsset;
+    use Assetic\Asset\GlobAsset;
+
+    $js = new AssetCollection(array(
+        //new FileAsset(PLUGINSURL.'/zebradialog/javascript/zebra_dialog.js'),
+        //new FileAsset(PLUGINSURL.'/scrollto/jquery.scrollTo.js'),
+        new FileAsset(PLUGINSURL.'/fileupload/jquery.fileupload.js'),
+        new FileAsset(PLUGINSURL.'/fileupload/jquery.iframe-transport.js'),
+        //new FileAsset(PLUGINSURL.'/jpicker/jpicker-1.1.6.min.js'),
+        new FileAsset(PLUGINSURL.'/watermark/jquery.watermarkinput.js'),
+        new FileAsset(PLUGINSURL.'/alphanumeric/jquery.alphanumeric.js'),
+        new FileAsset(PLUGINSURL.'/qtip/jquery.qtip-1.0.0-rc3.min.js'),
+        new FileAsset(PLUGINSURL.'/contextmenu/jquery.contextMenu.js'),
+        new FileAsset(PLUGINSURL.'/farbtastic/farbtastic.js'),
+        new FileAsset(PLUGINSURL.'/fgmenu/fg.menu.js'),
+        new FileAsset(PLUGINSURL.'/treeview/jquery.treeview.js'),
+        new FileAsset(PLUGINSURL.'/treeview/lib/jquery.cookie.js'),
+        new FileAsset(PLUGINSURL.'/layout/jquery.layout.min.js'),
+        new FileAsset(PLUGINSURL.'/wijmo/jquery.wijmo-open.all.2.2.0.min.js'),
+        new FileAsset(PLUGINSURL.'/jqgrid/js/i18n/grid.locale-pt-br.js'),
+        new FileAsset(PLUGINSURL.'/jqgrid/js/jquery.jqGrid.min.js'),
+        new FileAsset(PLUGINSURL.'/ejs/ejs.js'),
+        new FileAsset(PLUGINSURL.'/countdown/jquery.countdown.min.js'),
+        new FileAsset(PLUGINSURL.'/countdown/jquery.countdown-pt-BR.js'),
+
+        new FileAsset(MODULESURL.'/js/formatters.js'),
+        new FileAsset(MODULESURL.'/js/newfoldertree.js'),
+        new FileAsset(MODULESURL.'/js/tabs.js'),
+        new FileAsset(MODULESURL.'/js/alerts.js'),
+        new FileAsset(MODULESURL.'/js/folder.js'),
+        new FileAsset(MODULESURL.'/js/init.js')
+
+        //new FileAsset(PLUGINSURL.'/mask/jquery.maskedinput.js')
+    ));
+    header('Content-Type: text/javascript');
+    echo $js->dump();
+?>
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/BaseAsset.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/BaseAsset.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/BaseAsset.php	(revision 7265)
@@ -0,0 +1,172 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\Filter\FilterCollection;
+use Assetic\Filter\FilterInterface;
+
+/**
+ * A base abstract asset.
+ *
+ * The methods load() and getLastModified() are left undefined, although a
+ * reusable doLoad() method is available to child classes.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+abstract class BaseAsset implements AssetInterface
+{
+    private $filters;
+    private $sourceRoot;
+    private $sourcePath;
+    private $targetPath;
+    private $content;
+    private $loaded;
+    private $vars;
+    private $values;
+
+    /**
+     * Constructor.
+     *
+     * @param array  $filters    Filters for the asset
+     * @param string $sourceRoot The root directory
+     * @param string $sourcePath The asset path
+     * @param array  $vars
+     */
+    public function __construct($filters = array(), $sourceRoot = null, $sourcePath = null, array $vars = array())
+    {
+        $this->filters = new FilterCollection($filters);
+        $this->sourceRoot = $sourceRoot;
+        $this->sourcePath = $sourcePath;
+        $this->vars = $vars;
+        $this->values = array();
+        $this->loaded = false;
+    }
+
+    public function __clone()
+    {
+        $this->filters = clone $this->filters;
+    }
+
+    public function ensureFilter(FilterInterface $filter)
+    {
+        $this->filters->ensure($filter);
+    }
+
+    public function getFilters()
+    {
+        return $this->filters->all();
+    }
+
+    public function clearFilters()
+    {
+        $this->filters->clear();
+    }
+
+    /**
+     * Encapsulates asset loading logic.
+     *
+     * @param string          $content          The asset content
+     * @param FilterInterface $additionalFilter An additional filter
+     */
+    protected function doLoad($content, FilterInterface $additionalFilter = null)
+    {
+        $filter = clone $this->filters;
+        if ($additionalFilter) {
+            $filter->ensure($additionalFilter);
+        }
+
+        $asset = clone $this;
+        $asset->setContent($content);
+
+        $filter->filterLoad($asset);
+        $this->content = $asset->getContent();
+
+        $this->loaded = true;
+    }
+
+    public function dump(FilterInterface $additionalFilter = null)
+    {
+        if (!$this->loaded) {
+            $this->load();
+        }
+
+        $filter = clone $this->filters;
+        if ($additionalFilter) {
+            $filter->ensure($additionalFilter);
+        }
+
+        $asset = clone $this;
+        $filter->filterDump($asset);
+
+        return $asset->getContent();
+    }
+
+    public function getContent()
+    {
+        return $this->content;
+    }
+
+    public function setContent($content)
+    {
+        $this->content = $content;
+    }
+
+    public function getSourceRoot()
+    {
+        return $this->sourceRoot;
+    }
+
+    public function getSourcePath()
+    {
+        return $this->sourcePath;
+    }
+
+    public function getTargetPath()
+    {
+        return $this->targetPath;
+    }
+
+    public function setTargetPath($targetPath)
+    {
+        if ($this->vars) {
+            foreach ($this->vars as $var) {
+                if (false === strpos($targetPath, $var)) {
+                    throw new \RuntimeException(sprintf('The asset target path "%s" must contain the variable "{%s}".', $targetPath, $var));
+                }
+            }
+        }
+
+        $this->targetPath = $targetPath;
+    }
+
+    public function getVars()
+    {
+        return $this->vars;
+    }
+
+    public function setValues(array $values)
+    {
+        foreach ($values as $var => $v) {
+            if (!in_array($var, $this->vars, true)) {
+                throw new \InvalidArgumentException(sprintf('The asset with source path "%s" has no variable named "%s".', $this->sourcePath, $var));
+            }
+        }
+
+        $this->values = $values;
+        $this->loaded = false;
+    }
+
+    public function getValues()
+    {
+        return $this->values;
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCollection.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCollection.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCollection.php	(revision 7265)
@@ -0,0 +1,227 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\Asset\Iterator\AssetCollectionFilterIterator;
+use Assetic\Asset\Iterator\AssetCollectionIterator;
+use Assetic\Filter\FilterCollection;
+use Assetic\Filter\FilterInterface;
+
+/**
+ * A collection of assets.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class AssetCollection implements \IteratorAggregate, AssetCollectionInterface
+{
+    private $assets;
+    private $filters;
+    private $sourceRoot;
+    private $targetPath;
+    private $content;
+    private $clones;
+    private $vars;
+    private $values;
+
+    /**
+     * Constructor.
+     *
+     * @param array  $assets     Assets for the current collection
+     * @param array  $filters    Filters for the current collection
+     * @param string $sourceRoot The root directory
+     * @param array  $vars
+     */
+    public function __construct($assets = array(), $filters = array(), $sourceRoot = null, array $vars = array())
+    {
+        $this->assets = array();
+        foreach ($assets as $asset) {
+            $this->add($asset);
+        }
+
+        $this->filters = new FilterCollection($filters);
+        $this->sourceRoot = $sourceRoot;
+        $this->clones = new \SplObjectStorage();
+        $this->vars = $vars;
+        $this->values = array();
+    }
+
+    public function all()
+    {
+        return $this->assets;
+    }
+
+    public function add(AssetInterface $asset)
+    {
+        $this->assets[] = $asset;
+    }
+
+    public function removeLeaf(AssetInterface $needle, $graceful = false)
+    {
+        foreach ($this->assets as $i => $asset) {
+            $clone = isset($this->clones[$asset]) ? $this->clones[$asset] : null;
+            if (in_array($needle, array($asset, $clone), true)) {
+                unset($this->clones[$asset], $this->assets[$i]);
+
+                return true;
+            }
+
+            if ($asset instanceof AssetCollectionInterface && $asset->removeLeaf($needle, true)) {
+                return true;
+            }
+        }
+
+        if ($graceful) {
+            return false;
+        }
+
+        throw new \InvalidArgumentException('Leaf not found.');
+    }
+
+    public function replaceLeaf(AssetInterface $needle, AssetInterface $replacement, $graceful = false)
+    {
+        foreach ($this->assets as $i => $asset) {
+            $clone = isset($this->clones[$asset]) ? $this->clones[$asset] : null;
+            if (in_array($needle, array($asset, $clone), true)) {
+                unset($this->clones[$asset]);
+                $this->assets[$i] = $replacement;
+
+                return true;
+            }
+
+            if ($asset instanceof AssetCollectionInterface && $asset->replaceLeaf($needle, $replacement, true)) {
+                return true;
+            }
+        }
+
+        if ($graceful) {
+            return false;
+        }
+
+        throw new \InvalidArgumentException('Leaf not found.');
+    }
+
+    public function ensureFilter(FilterInterface $filter)
+    {
+        $this->filters->ensure($filter);
+    }
+
+    public function getFilters()
+    {
+        return $this->filters->all();
+    }
+
+    public function clearFilters()
+    {
+        $this->filters->clear();
+    }
+
+    public function load(FilterInterface $additionalFilter = null)
+    {
+        // loop through leaves and load each asset
+        $parts = array();
+        foreach ($this as $asset) {
+            $asset->load($additionalFilter);
+            $parts[] = $asset->getContent();
+        }
+
+        $this->content = implode("\n", $parts);
+    }
+
+    public function dump(FilterInterface $additionalFilter = null)
+    {
+        // loop through leaves and dump each asset
+        $parts = array();
+        foreach ($this as $asset) {
+            $parts[] = $asset->dump($additionalFilter);
+        }
+
+        return implode("\n", $parts);
+    }
+
+    public function getContent()
+    {
+        return $this->content;
+    }
+
+    public function setContent($content)
+    {
+        $this->content = $content;
+    }
+
+    public function getSourceRoot()
+    {
+        return $this->sourceRoot;
+    }
+
+    public function getSourcePath()
+    {
+    }
+
+    public function getTargetPath()
+    {
+        return $this->targetPath;
+    }
+
+    public function setTargetPath($targetPath)
+    {
+        $this->targetPath = $targetPath;
+    }
+
+    /**
+     * Returns the highest last-modified value of all assets in the current collection.
+     *
+     * @return integer|null A UNIX timestamp
+     */
+    public function getLastModified()
+    {
+        if (!count($this->assets)) {
+            return;
+        }
+
+        $mtime = 0;
+        foreach ($this as $asset) {
+            $assetMtime = $asset->getLastModified();
+            if ($assetMtime > $mtime) {
+                $mtime = $assetMtime;
+            }
+        }
+
+        return $mtime;
+    }
+
+    /**
+     * Returns an iterator for looping recursively over unique leaves.
+     */
+    public function getIterator()
+    {
+        return new \RecursiveIteratorIterator(new AssetCollectionFilterIterator(new AssetCollectionIterator($this, $this->clones)));
+    }
+
+    public function getVars()
+    {
+        return $this->vars;
+    }
+
+    public function setValues(array $values)
+    {
+        $this->values = $values;
+
+        foreach ($this as $asset) {
+            $asset->setValues(array_intersect_key($values, array_flip($asset->getVars())));
+        }
+    }
+
+    public function getValues()
+    {
+        return $this->values;
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCollectionInterface.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCollectionInterface.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetCollectionInterface.php	(revision 7265)
@@ -0,0 +1,59 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+/**
+ * An asset collection.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+interface AssetCollectionInterface extends AssetInterface, \Traversable
+{
+    /**
+     * Returns all child assets.
+     *
+     * @return array An array of AssetInterface objects
+     */
+    public function all();
+
+    /**
+     * Adds an asset to the current collection.
+     *
+     * @param AssetInterface $asset An asset
+     */
+    public function add(AssetInterface $asset);
+
+    /**
+     * Removes a leaf.
+     *
+     * @param AssetInterface $leaf      The leaf to remove
+     * @param Boolean        $graceful  Whether the failure should return false or throw an exception
+     *
+     * @return Boolean Whether the asset has been found
+     *
+     * @throws \InvalidArgumentException If the asset cannot be found
+     */
+    public function removeLeaf(AssetInterface $leaf, $graceful = false);
+
+    /**
+     * Replaces an existing leaf with a new one.
+     *
+     * @param AssetInterface $needle      The current asset to replace
+     * @param AssetInterface $replacement The new asset
+     * @param Boolean        $graceful  Whether the failure should return false or throw an exception
+     *
+     * @return Boolean Whether the asset has been found
+     *
+     * @throws \InvalidArgumentException If the asset cannot be found
+     */
+    public function replaceLeaf(AssetInterface $needle, AssetInterface $replacement, $graceful = false);
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetReference.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetReference.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/AssetReference.php	(revision 7265)
@@ -0,0 +1,133 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\AssetManager;
+use Assetic\Filter\FilterInterface;
+
+/**
+ * A reference to an asset in the asset manager.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class AssetReference implements AssetInterface
+{
+    private $am;
+    private $name;
+    private $filters = array();
+
+    public function __construct(AssetManager $am, $name)
+    {
+        $this->am = $am;
+        $this->name = $name;
+    }
+
+    public function ensureFilter(FilterInterface $filter)
+    {
+        $this->filters[] = $filter;
+    }
+
+    public function getFilters()
+    {
+        $this->flushFilters();
+
+        return $this->callAsset(__FUNCTION__);
+    }
+
+    public function clearFilters()
+    {
+        $this->filters = array();
+        $this->callAsset(__FUNCTION__);
+    }
+
+    public function load(FilterInterface $additionalFilter = null)
+    {
+        $this->flushFilters();
+
+        return $this->callAsset(__FUNCTION__, array($additionalFilter));
+    }
+
+    public function dump(FilterInterface $additionalFilter = null)
+    {
+        $this->flushFilters();
+
+        return $this->callAsset(__FUNCTION__, array($additionalFilter));
+    }
+
+    public function getContent()
+    {
+        return $this->callAsset(__FUNCTION__);
+    }
+
+    public function setContent($content)
+    {
+        $this->callAsset(__FUNCTION__, array($content));
+    }
+
+    public function getSourceRoot()
+    {
+        return $this->callAsset(__FUNCTION__);
+    }
+
+    public function getSourcePath()
+    {
+        return $this->callAsset(__FUNCTION__);
+    }
+
+    public function getTargetPath()
+    {
+        return $this->callAsset(__FUNCTION__);
+    }
+
+    public function setTargetPath($targetPath)
+    {
+        $this->callAsset(__FUNCTION__, array($targetPath));
+    }
+
+    public function getLastModified()
+    {
+        return $this->callAsset(__FUNCTION__);
+    }
+
+    public function getVars()
+    {
+        return $this->callAsset(__FUNCTION__);
+    }
+
+    public function getValues()
+    {
+        return $this->callAsset(__FUNCTION__);
+    }
+
+    public function setValues(array $values)
+    {
+        $this->callAsset(__FUNCTION__, array($values));
+    }
+
+    // private
+
+    private function callAsset($method, $arguments = array())
+    {
+        $asset = $this->am->get($this->name);
+
+        return call_user_func_array(array($asset, $method), $arguments);
+    }
+
+    private function flushFilters()
+    {
+        $asset = $this->am->get($this->name);
+
+        while ($filter = array_shift($this->filters)) {
+            $asset->ensureFilter($filter);
+        }
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/FileAsset.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/FileAsset.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/FileAsset.php	(revision 7265)
@@ -0,0 +1,78 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\Util\PathUtils;
+use Assetic\Filter\FilterInterface;
+
+/**
+ * Represents an asset loaded from a file.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class FileAsset extends BaseAsset
+{
+    private $source;
+
+    /**
+     * Constructor.
+     *
+     * @param string $source     An absolute path
+     * @param array  $filters    An array of filters
+     * @param string $sourceRoot The source asset root directory
+     * @param string $sourcePath The source asset path
+     * @param array  $vars
+     *
+     * @throws \InvalidArgumentException If the supplied root doesn't match the source when guessing the path
+     */
+    public function __construct($source, $filters = array(), $sourceRoot = null, $sourcePath = null, array $vars = array())
+    {
+        if (null === $sourceRoot) {
+            $sourceRoot = dirname($source);
+            if (null === $sourcePath) {
+                $sourcePath = basename($source);
+            }
+        } elseif (null === $sourcePath) {
+            if (0 !== strpos($source, $sourceRoot)) {
+                throw new \InvalidArgumentException(sprintf('The source "%s" is not in the root directory "%s"', $source, $sourceRoot));
+            }
+
+            $sourcePath = substr($source, strlen($sourceRoot) + 1);
+        }
+
+        $this->source = $source;
+
+        parent::__construct($filters, $sourceRoot, $sourcePath, $vars);
+    }
+
+    public function load(FilterInterface $additionalFilter = null)
+    {
+        $source = PathUtils::resolvePath($this->source, $this->getVars(), $this->getValues());
+
+        if (!is_file($source)) {
+            throw new \RuntimeException(sprintf('The source file "%s" does not exist.', $source));
+        }
+
+        $this->doLoad(file_get_contents($source), $additionalFilter);
+    }
+
+    public function getLastModified()
+    {
+        $source = PathUtils::resolvePath($this->source, $this->getVars(), $this->getValues());
+
+        if (!is_file($source)) {
+            throw new \RuntimeException(sprintf('The source file "%s" does not exist.', $source));
+        }
+
+        return filemtime($source);
+    }
+}
Index: sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/HttpAsset.php
===================================================================
--- sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/HttpAsset.php	(revision 7265)
+++ sandbox/newExpressoMail/newExpressoMail/Assetic/Asset/HttpAsset.php	(revision 7265)
@@ -0,0 +1,82 @@
+<?php
+
+/*
+ * This file is part of the Assetic package, an OpenSky project.
+ *
+ * (c) 2010-2012 OpenSky Project Inc
+ *
+ * For the full copyright and license information, please view the LICENSE
+ * file that was distributed with this source code.
+ */
+
+namespace Assetic\Asset;
+
+use Assetic\Util\PathUtils;
+
+use Assetic\Filter\FilterInterface;
+
+/**
+ * Represents an asset loaded via an HTTP request.
+ *
+ * @author Kris Wallsmith <kris.wallsmith@gmail.com>
+ */
+class HttpAsset extends BaseAsset
+{
+    private $sourceUrl;
+    private $ignoreErrors;
+
+    /**
+     * Constructor.
+     *
+     * @param string  $sourceUrl    The source URL
+     * @param array   $filters      An array of filters
+     * @param Boolean $ignoreErrors
+     * @param array   $vars
+     *
+     * @throws \InvalidArgumentException If the first argument is not an URL
+     */
+    public function __construct($sourceUrl, $filters = array(), $ignoreErrors = false, array $vars = array())
+    {
+        if (0 === strpos($sourceUrl, '//')) {
+            $sourceUrl = 'http:'.$sourceUrl;
+        } elseif (false === strpos($sourceUrl, '://')) {
+            throw new \InvalidArgumentException(sprintf('"%s" is not a valid URL.', $sourceUrl));
+        }
+
+        $this->sourceUrl = $sourceUrl;
+        $this->ignoreErrors = $ignoreErrors;
+
+        list($scheme, $url) = explode('://', $sourceUrl, 2);
+        list($host, $path) = explode('/', $url, 2);
+
+        parent::__construct($filters, $scheme.'://'.$host, $path, $vars);
+    }
+
+    public function load(FilterInterface $additionalFilter = null)
+    {
+        if (false === $content = @file_get_contents(PathUtils::resolvePath(
+                $this->sourceUrl, $this->getVars(), $this->getValues()))
+        ) {
+            if ($this->ignoreErrors) {
+                return;
+            }
+
+            throw new \RuntimeException(sprintf('Unable to load asset from URL "%s"', $this->sourceUrl));
+        }
+
+        $this->doLoad($content, $additionalFilter);
+    }
+
+    public function getLastModified()
+    {
+        if (false !== @file_get_contents($this->sourceUrl, false, stream_context_create(array('http' => array('method' => 'HEAD'))))) {
+            foreach ($http_response_header as $header) {
+                if (0 === stripos($header, 'Last-Modified: ')) {
+                    list(, $mtime) = explode(':', $header, 2);
+
+                    return strtotime(trim($mtime));
+                }
+            }
+        }
+    }
+}
